# Copyright (c) 2016-2017 Anki, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License in the file LICENSE.txt or at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
Autogenerated python message buffer code.
Source: clad/types/animationTrigger.clad
Full command line: ../tools/message-buffers/emitters/Python_emitter.py -C ./src/ -I ../robot/clad/src/ ../coretech/vision/clad/src/ ../coretech/common/clad/src/ ../lib/util/source/anki/clad -o ../generated/cladPython// clad/types/animationTrigger.clad
"""

from __future__ import absolute_import
from __future__ import print_function

def _modify_path():
  import inspect, os, sys
  search_paths = [
    '../..',
    '../../../../tools/message-buffers/support/python',
  ]
  currentpath = os.path.abspath(os.path.dirname(inspect.getfile(inspect.currentframe())))
  for search_path in search_paths:
    search_path = os.path.normpath(os.path.abspath(os.path.realpath(os.path.join(currentpath, search_path))))
    if search_path not in sys.path:
      sys.path.insert(0, search_path)
_modify_path()

import msgbuffers

Anki = msgbuffers.Namespace()
Anki.Cozmo = msgbuffers.Namespace()

class AnimationTrigger(object):
  "Automatically-generated int_32 enumeration."
  AcknowledgeFaceInitPause                = 0
  AcknowledgeFaceNamed                    = 1
  AcknowledgeFaceUnnamed                  = 2
  AcknowledgeObject                       = 3
  AskToBeRightedLeft                      = 4
  AskToBeRightedRight                     = 5
  AudioTestAnim                           = 6
  BlockReact                              = 7
  BouncerGetIn                            = 8
  BouncerGetOut                           = 9
  BouncerIdeaToPlay                       = 10
  BouncerIntoScore1                       = 11
  BouncerIntoScore2                       = 12
  BouncerIntoScore3                       = 13
  BouncerRequestToPlay                    = 14
  BouncerTimeout                          = 15
  BouncerWait                             = 16
  BuildPyramidFirstBlockOnSide            = 17
  BuildPyramidFirstBlockUpright           = 18
  BuildPyramidLookForFace                 = 19
  BuildPyramidReactToBase                 = 20
  BuildPyramidSecondBlockOnSide           = 21
  BuildPyramidSecondBlockUpright          = 22
  BuildPyramidSuccess                     = 23
  BuildPyramidThankUser                   = 24
  BuildPyramidThirdBlockOnSide            = 25
  BuildPyramidThirdBlockUpright           = 26
  CantHandleTallStack                     = 27
  PatternGuessNewIdea                     = 28
  PatternGuessThinking                    = 29
  CodeLab123Go                            = 30
  CodeLabAmazed                           = 31
  CodeLabBored                            = 32
  CodeLabCat                              = 33
  CodeLabCelebrate                        = 34
  CodeLabChatty                           = 35
  CodeLabConducting                       = 36
  CodeLabCurious                          = 37
  CodeLabDancingMambo                     = 38
  CodeLabDejected                         = 39
  CodeLabDizzy                            = 40
  CodeLabDizzyEnd                         = 41
  CodeLabDog                              = 42
  CodeLabEnergyEat                        = 43
  CodeLabEnter                            = 44
  CodeLabExcited                          = 45
  CodeLabExit                             = 46
  CodeLabFireTruck                        = 47
  CodeLabFrustrated                       = 48
  CodeLabGetInPos                         = 49
  CodeLabHappy                            = 50
  CodeLabHelium                           = 51
  CodeLabHiccup                           = 52
  CodeLabIDK                              = 53
  CodeLabIdle                             = 54
  CodeLabLose                             = 55
  CodeLabNo                               = 56
  CodeLabPartyTime                        = 57
  CodeLabReactHappy                       = 58
  CodeLabSleep                            = 59
  CodeLabSneeze                           = 60
  CodeLabSurprise                         = 61
  CodeLabTakaTaka                         = 62
  CodeLabTapCube                          = 63
  CodeLabThinking                         = 64
  CodeLabUnhappy                          = 65
  CodeLabVictory                          = 66
  CodeLabWhee1                            = 67
  CodeLabWhee2                            = 68
  CodeLabWhee3                            = 69
  CodeLabWhee4                            = 70
  CodeLabWhew                             = 71
  CodeLabWhoa                             = 72
  CodeLabWin                              = 73
  CodeLabWondering                        = 74
  CodeLabYes                              = 75
  CodeLabYuck                             = 76
  ConnectWakeUp                           = 77
  ConnectWakeUp_SevereEnergy              = 78
  ConnectWakeUp_SevereRepair              = 79
  ComeHere_AlreadyHere                    = 80
  ComeHere_SearchForFace                  = 81
  ComeHere_SearchForFace_FoundFace        = 82
  CozmoSaysGetIn                          = 83
  CozmoSaysGetOut                         = 84
  CozmoSaysSpeakGetInShort                = 85
  CozmoSaysSpeakGetInMedium               = 86
  CozmoSaysSpeakGetInLong                 = 87
  CozmoSaysSpeakGetOutShort               = 88
  CozmoSaysSpeakGetOutMedium              = 89
  CozmoSaysSpeakGetOutLong                = 90
  CozmoSaysSpeakLoop                      = 91
  CozmoSaysBadWord                        = 92
  CozmoSaysIdle                           = 93
  CubeMovedSense                          = 94
  CubeMovedUpset                          = 95
  CubePounceFake                          = 96
  CubePounceGetIn                         = 97
  CubePounceGetOut                        = 98
  CubePounceGetReady                      = 99
  CubePounceGetUnready                    = 100
  CubePounceIdleLiftDown                  = 101
  CubePounceIdleLiftUp                    = 102
  CubePounceLoseHand                      = 103
  CubePounceLoseRound                     = 104
  CubePounceLoseSession                   = 105
  CubePouncePounceClose                   = 106
  CubePouncePounceNormal                  = 107
  CubePounceWinHand                       = 108
  CubePounceWinRound                      = 109
  CubePounceWinSession                    = 110
  DanceMambo                              = 111
  DemoSpeedTapCozmoWin                    = 112
  DemoSpeedTapCozmoLose                   = 113
  DizzyReactionHard                       = 114
  DizzyReactionMedium                     = 115
  DizzyReactionSoft                       = 116
  DizzyShakeLoop                          = 117
  DizzyShakeStop                          = 118
  DizzyStillPickedUp                      = 119
  DriveEndAngry                           = 120
  DriveEndDefault                         = 121
  DriveEndHappy                           = 122
  DriveEndLaunch                          = 123
  DriveLoopAngry                          = 124
  DriveLoopDefault                        = 125
  DriveLoopHappy                          = 126
  DriveLoopLaunch                         = 127
  DriveStartAngry                         = 128
  DriveStartDefault                       = 129
  DriveStartHappy                         = 130
  DriveStartLaunch                        = 131
  DroneModeBackwardDrivingEnd             = 132
  DroneModeBackwardDrivingLoop            = 133
  DroneModeBackwardDrivingStart           = 134
  DroneModeCliffEvent                     = 135
  DroneModeForwardDrivingEnd              = 136
  DroneModeForwardDrivingLoop             = 137
  DroneModeForwardDrivingStart            = 138
  DroneModeGetIn                          = 139
  DroneModeGetOut                         = 140
  DroneModeIdle                           = 141
  DroneModeKeepAlive                      = 142
  DroneModeTurboDrivingStart              = 143
  EarnedSparks                            = 144
  FacePlantRoll                           = 145
  FacePlantRollArmUp                      = 146
  FailedToRightFromFace                   = 147
  FeedingAteFullEnough_Normal             = 148
  FeedingAteFullEnough_Severe             = 149
  FeedingAteNotFullEnough_Normal          = 150
  FeedingAteNotFullEnough_Severe          = 151
  FeedingDrivingGetIn_Severe              = 152
  FeedingDrivingGetOut_Severe             = 153
  FeedingDrivingLoop_Severe               = 154
  FeedingPlaceLiftOnCube_Normal           = 155
  FeedingPlaceLiftOnCube_Severe           = 156
  FeedingIdleSearch_Normal                = 157
  FeedingIdleSearch_Severe                = 158
  FeedingIdleSearchForFaces_Normal        = 159
  FeedingIdleSearchForFaces_Severe        = 160
  FeedingIdleWaitForFullCube_Normal       = 161
  FeedingIdleWaitForFullCube_Severe       = 162
  FeedingIdleWaitForShakeNoHead_Severe    = 163
  FeedingIdleWaitForShake_Normal          = 164
  FeedingIdleWaitForShake_Severe          = 165
  FeedingInterrupted                      = 166
  FeedingInterrupted_Severe               = 167
  FeedingSearchRequest                    = 168
  FeedingSearchRequest_Severe             = 169
  FeedingSearchFailure                    = 170
  FeedingSearchFailure_Severe             = 171
  FeedingReactToFullCube_Normal           = 172
  FeedingReactToFullCube_Severe           = 173
  FeedingReactToSeeCube_Normal            = 174
  FeedingReactToSeeCube_Severe            = 175
  FeedingReactToShake_Normal              = 176
  FeedingReactToShake_Severe              = 177
  FistBumpIdle                            = 178
  FistBumpRequestOnce                     = 179
  FistBumpRequestRetry                    = 180
  FistBumpSuccess                         = 181
  FistBumpLeftHanging                     = 182
  FlipDownFromBack                        = 183
  FrustratedByFailure                     = 184
  FrustratedByFailureMajor                = 185
  GameSetupGetIn                          = 186
  GameSetupGetOut                         = 187
  GameSetupIdle                           = 188
  GameSetupReaction                       = 189
  GoToSleepGetIn                          = 190
  GoToSleepGetOut                         = 191
  GoToSleepOff                            = 192
  GoToSleepSleeping                       = 193
  GuardDogBusted                          = 194
  GuardDogCubeDisconnect                  = 195
  GuardDogFakeout                         = 196
  GuardDogInterruption                    = 197
  GuardDogPlayerSuccess                   = 198
  GuardDogPulse                           = 199
  GuardDogSettle                          = 200
  GuardDogSleepLoop                       = 201
  GuardDogTimeout                         = 202
  GuardDogTimeoutCubesTouched             = 203
  GuardDogTimeoutCubesUntouched           = 204
  Hiccup                                  = 205
  HiccupGetIn                             = 206
  HiccupPlayerCure                        = 207
  HiccupRobotOnBack                       = 208
  HiccupRobotOnFace                       = 209
  HiccupRobotPickedUp                     = 210
  HiccupSelfCure                          = 211
  HikingDrivingEnd                        = 212
  HikingDrivingLoop                       = 213
  HikingDrivingStart                      = 214
  HikingInterestingEdgeThought            = 215
  HikingIntro                             = 216
  HikingLookAround                        = 217
  HikingObserve                           = 218
  HikingReactToEdge                       = 219
  HikingReactToNewArea                    = 220
  HikingReactToPossibleMarker             = 221
  HikingSquintEnd                         = 222
  HikingSquintLoop                        = 223
  HikingSquintStart                       = 224
  HikingWakeUpOffCharger                  = 225
  IdleOnCharger                           = 226
  InteractWithFaceTrackingIdle            = 227
  InteractWithFacesInitialNamed           = 228
  InteractWithFacesInitialUnnamed         = 229
  KnockOverEyes                           = 230
  KnockOverFailure                        = 231
  KnockOverGrabAttempt                    = 232
  KnockOverPreActionNamedFace             = 233
  KnockOverPreActionUnnamedFace           = 234
  KnockOverSuccess                        = 235
  LaserAcknowledge                        = 236
  LaserDriveEnd                           = 237
  LaserDriveLoop                          = 238
  LaserDriveStart                         = 239
  LaserFace                               = 240
  LaserGetOut                             = 241
  LaserPounce                             = 242
  LookInPlaceForFacesBodyPause            = 243
  LookInPlaceForFacesHeadMovePause        = 244
  MajorFail                               = 245
  MajorWin                                = 246
  MeetCozmoGetIn                          = 247
  MeetCozmoLookFaceGetIn                  = 248
  MeetCozmoLookFaceGetOut                 = 249
  MeetCozmoScanningIdle                   = 250
  MeetCozmoFirstEnrollmentSayName         = 251
  MeetCozmoFirstEnrollmentRepeatName      = 252
  MeetCozmoFirstEnrollmentCelebration     = 253
  MeetCozmoReEnrollmentSayName            = 254
  MeetCozmoRenameFaceSayName              = 255
  MeetCozmoLookFaceInterrupt              = 256
  MemoryMatchPlayerWinHand                = 257
  MemoryMatchPlayerWinHandLong            = 258
  MemoryMatchPlayerWinHandSolo            = 259
  MemoryMatchPlayerLoseHand               = 260
  MemoryMatchPlayerLoseHandSolo           = 261
  MemoryMatchCozmoWinHand                 = 262
  MemoryMatchCozmoLoseHand                = 263
  MemoryMatchCozmoWinGame                 = 264
  MemoryMatchPlayerWinGame                = 265
  MemoryMatchSoloGameOver                 = 266
  MemoryMatchReactToPattern               = 267
  MemoryMatchReactToPatternSolo           = 268
  MemoryMatchPointCenter                  = 269
  MemoryMatchPointLeftBig                 = 270
  MemoryMatchPointLeftSmall               = 271
  MemoryMatchPointRightBig                = 272
  MemoryMatchPointRightSmall              = 273
  MemoryMatchPointCenterFast              = 274
  MemoryMatchPointLeftBigFast             = 275
  MemoryMatchPointLeftSmallFast           = 276
  MemoryMatchPointRightBigFast            = 277
  MemoryMatchPointRightSmallFast          = 278
  MemoryMatchCozmoGetOut                  = 279
  MemoryMatchCozmoFollowTapsSoundOnly     = 280
  NamedFaceInitialGreeting                = 281
  NeedsMildLowEnergyRequest               = 282
  NeedsMildLowPlayRequest                 = 283
  NeedsMildLowRepairRequest               = 284
  NeedsSevereLowEnergyCliffReact          = 285
  NeedsSevereLowEnergyDrivingEnd          = 286
  NeedsSevereLowEnergyDrivingLoop         = 287
  NeedsSevereLowEnergyDrivingStart        = 288
  NeedsSevereLowEnergyForceGetOut         = 289
  NeedsSevereLowEnergyGetIn               = 290
  NeedsSevereLowEnergyIdle                = 291
  NeedsSevereLowEnergyRequest             = 292
  NeedsSevereLowEnergySlopeReact          = 293
  NeedsSevereLowPlayForceGetOut           = 294
  NeedsSevereLowPlayGetIn                 = 295
  NeedsSevereLowPlayRequest               = 296
  NeedsSevereLowRepairCliffReact          = 297
  NeedsSevereLowRepairDrivingEnd          = 298
  NeedsSevereLowRepairDrivingLoop         = 299
  NeedsSevereLowRepairDrivingStart        = 300
  NeedsSevereLowRepairForceGetOut         = 301
  NeedsSevereLowRepairGetIn               = 302
  NeedsSevereLowRepairIdle                = 303
  NeedsSevereLowRepairRequest             = 304
  NeedsSevereLowRepairSlopeReact          = 305
  NeutralFace                             = 306
  NothingToDoBoredEvent                   = 307
  NothingToDoBoredIdle                    = 308
  NothingToDoBoredIntro                   = 309
  NothingToDoBoredOutro                   = 310
  OnLearnedPlayerName                     = 311
  OnSawNewNamedFace                       = 312
  OnSawNewUnnamedFace                     = 313
  OnSawOldNamedFace                       = 314
  OnSawOldUnnamedFace                     = 315
  OnSpeedtapCozmoConfirm                  = 316
  OnSpeedtapFakeout                       = 317
  OnSpeedtapGameCozmoWinHighIntensity     = 318
  OnSpeedtapGameCozmoWinLowIntensity      = 319
  OnSpeedtapGamePlayerWinHighIntensity    = 320
  OnSpeedtapGamePlayerWinLowIntensity     = 321
  OnSpeedtapGetOut                        = 322
  OnSpeedtapHandCozmoWin                  = 323
  OnSpeedtapHandPlayerWin                 = 324
  OnSpeedtapIdle                          = 325
  OnSpeedtapRoundCozmoWinHighIntensity    = 326
  OnSpeedtapRoundCozmoWinLowIntensity     = 327
  OnSpeedtapRoundPlayerWinHighIntensity   = 328
  OnSpeedtapRoundPlayerWinLowIntensity    = 329
  OnSpeedtapTap                           = 330
  OnWaitForCubesMinigameSetup             = 331
  OnWiggle                                = 332
  OnboardingBirth                         = 333
  OnboardingCubeDockFail                  = 334
  OnboardingDiscoverCube                  = 335
  OnboardingDriveEnd                      = 336
  OnboardingDriveLoop                     = 337
  OnboardingDriveStart                    = 338
  OnboardingEyesOn                        = 339
  OnboardingHelloPlayer                   = 340
  OnboardingHelloWorld                    = 341
  OnboardingIdle                          = 342
  OnboardingIdleEnergy                    = 343
  OnboardingIdlePlay                      = 344
  OnboardingIdleRepair                    = 345
  OnboardingInteractWithCube              = 346
  OnboardingPreBirth                      = 347
  OnboardingReactToCube                   = 348
  OnboardingReactToCubePutDown            = 349
  OnboardingReactToFace                   = 350
  OnboardingSoundOnlyLiftEffortPickup     = 351
  OnboardingSoundOnlyLiftEffortPlaceLow   = 352
  OnboardingGetOut                        = 353
  OnboardingWakeUpDriveOffCharger         = 354
  PeekABooGetIn                           = 355
  PeekABooGetOutHappy                     = 356
  PeekABooGetOutSad                       = 357
  PeekABooHighIntensity                   = 358
  PeekABooIdle                            = 359
  PeekABooLowIntensity                    = 360
  PeekABooMedIntensity                    = 361
  PeekABooNoUserInteraction               = 362
  PeekABooShort                           = 363
  PeekABooSurprised                       = 364
  PetDetectionCat                         = 365
  PetDetectionDog                         = 366
  PetDetectionShort                       = 367
  PetDetectionShort_Cat                   = 368
  PetDetectionShort_Dog                   = 369
  PetDetectionSneeze                      = 370
  PickupHelperPreActionNamedFace          = 371
  PickupHelperPreActionUnnamedFace        = 372
  PlacedOnCharger                         = 373
  PopAWheelieInitial                      = 374
  PopAWheeliePreActionNamedFace           = 375
  PopAWheeliePreActionUnnamedFace         = 376
  PopAWheelieRealign                      = 377
  PopAWheelieRetry                        = 378
  PounceDriveEnd                          = 379
  PounceDriveLoop                         = 380
  PounceDriveStart                        = 381
  PounceFace                              = 382
  PounceFail                              = 383
  PounceGetOut                            = 384
  PounceInitial                           = 385
  PouncePounce                            = 386
  PounceSuccess                           = 387
  ProceduralLive                          = 388
  PutDownBlockKeepAlive                   = 389
  PutDownBlockPutDown                     = 390
  ReactToBlockPickupSuccess               = 391
  ReactToBlockRetryPickup                 = 392
  ReactToCliff                            = 393
  ReactToCliffDetectorStop                = 394
  ReactToFalling                          = 395
  ReactToImpact                           = 396
  ReactToObstacle                         = 397
  ReactToMotorCalibration                 = 398
  ReactToNewBlockAsk                      = 399
  ReactToNewBlockBig                      = 400
  ReactToNewBlockSmall                    = 401
  ReactToOnLeftSide                       = 402
  ReactToOnRightSide                      = 403
  ReactToPerchedOnBlock                   = 404
  ReactToPickup                           = 405
  ReactToPokeReaction                     = 406
  ReactToPokeStartled                     = 407
  ReactToUnexpectedMovement               = 408
  ReactToUnexpectedMovement_Severe_Energy = 409
  ReactToUnexpectedMovement_Severe_Repair = 410
  RepairFailMild                          = 411
  RepairFailSevere                        = 412
  RepairFixMildGetIn                      = 413
  RepairFixMildGetOut                     = 414
  RepairFixMildGetReady                   = 415
  RepairFixMildHeadDown                   = 416
  RepairFixMildHeadUp                     = 417
  RepairFixMildIdle                       = 418
  RepairFixMildLiftDown                   = 419
  RepairFixMildLiftUp                     = 420
  RepairFixMildLowerLift                  = 421
  RepairFixMildRaiseLift                  = 422
  RepairFixMildRoundReact                 = 423
  RepairFixMildWheelsBack                 = 424
  RepairFixMildWheelsForward              = 425
  RepairFixSevereGetIn                    = 426
  RepairFixSevereGetOut                   = 427
  RepairFixSevereGetReady                 = 428
  RepairFixSevereHeadDown                 = 429
  RepairFixSevereHeadUp                   = 430
  RepairFixSevereIdle                     = 431
  RepairFixSevereLiftDown                 = 432
  RepairFixSevereLiftUp                   = 433
  RepairFixSevereLowerLift                = 434
  RepairFixSevereRaiseLift                = 435
  RepairFixSevereRoundReact               = 436
  RepairFixSevereWheelsBack               = 437
  RepairFixSevereWheelsForward            = 438
  RepairIdleFullyRepaired                 = 439
  RepairPartRepaired_Head_Mild            = 440
  RepairPartRepaired_Lift_Mild            = 441
  RepairPartRepaired_Tread_Mild           = 442
  RequestGameInterrupt                    = 443
  RequestGameKeepAwayAccept0              = 444
  RequestGameKeepAwayAccept1              = 445
  RequestGameKeepAwayDeny0                = 446
  RequestGameKeepAwayDeny1                = 447
  RequestGameKeepAwayIdle0                = 448
  RequestGameKeepAwayIdle1                = 449
  RequestGameKeepAwayInitial0             = 450
  RequestGameKeepAwayInitial1             = 451
  RequestGameKeepAwayPreDrive0            = 452
  RequestGameKeepAwayPreDrive1            = 453
  RequestGameKeepAwayRequest0             = 454
  RequestGameKeepAwayRequest1             = 455
  RequestGameMemoryMatchAccept0           = 456
  RequestGameMemoryMatchAccept1           = 457
  RequestGameMemoryMatchDeny0             = 458
  RequestGameMemoryMatchDeny1             = 459
  RequestGameMemoryMatchIdle0             = 460
  RequestGameMemoryMatchIdle1             = 461
  RequestGameMemoryMatchInitial0          = 462
  RequestGameMemoryMatchInitial1          = 463
  RequestGameMemoryMatchPreDrive0         = 464
  RequestGameMemoryMatchPreDrive1         = 465
  RequestGameMemoryMatchRequest0          = 466
  RequestGameMemoryMatchRequest1          = 467
  RequestGamePickupFail                   = 468
  RequestGameSpeedTapAccept0              = 469
  RequestGameSpeedTapAccept1              = 470
  RequestGameSpeedTapDeny0                = 471
  RequestGameSpeedTapDeny1                = 472
  RequestGameSpeedTapIdle0                = 473
  RequestGameSpeedTapIdle1                = 474
  RequestGameSpeedTapInitial0             = 475
  RequestGameSpeedTapInitial1             = 476
  RequestGameSpeedTapPreDrive0            = 477
  RequestGameSpeedTapPreDrive1            = 478
  RequestGameSpeedTapRequest0             = 479
  RequestGameSpeedTapRequest1             = 480
  RollBlockInitial                        = 481
  RollBlockPreActionNamedFace             = 482
  RollBlockPreActionUnnamedFace           = 483
  RollBlockPutDown                        = 484
  RollBlockRealign                        = 485
  RollBlockRetry                          = 486
  RollBlockSuccess                        = 487
  SdkTextToSpeech                         = 488
  Shiver                                  = 489
  Shocked                                 = 490
  Singing_80bpm                           = 491
  Singing_100bpm                          = 492
  Singing_120bpm                          = 493
  Singing_GetIn                           = 494
  Singing_GetOut                          = 495
  Sleeping                                = 496
  SoftSparkUpgradeLift                    = 497
  SoftSparkUpgradeTracks                  = 498
  SoundOnlyLiftEffortPickup               = 499
  SoundOnlyLiftEffortPlaceHigh            = 500
  SoundOnlyLiftEffortPlaceLow             = 501
  SoundOnlyLiftEffortPlaceRoll            = 502
  SoundOnlyRamIntoBlock                   = 503
  SoundOnlyTurnSmall                      = 504
  SparkDrivingLoop                        = 505
  SparkDrivingStart                       = 506
  SparkDrivingStop                        = 507
  SparkFailure                            = 508
  SparkGetIn                              = 509
  SparkGetOut                             = 510
  SparkIdle                               = 511
  SparkPickupFinalCubeReaction            = 512
  SparkPickupInitialCubeReaction          = 513
  SparkSuccess                            = 514
  SpeedTapDrivingEnd                      = 515
  SpeedTapDrivingLoop                     = 516
  SpeedTapDrivingStart                    = 517
  StackBlocksSuccess                      = 518
  StartSleeping                           = 519
  SuccessfulWheelie                       = 520
  Surprise                                = 521
  TurtleRoll                              = 522
  UnitTestAnim                            = 523
  VC_Alrighty                             = 524
  VC_HowAreYouDoing_AllGood               = 525
  VC_Listening                            = 526
  VC_LookDownForLaser                     = 527
  VC_LookDownNoLaser                      = 528
  VC_NoFollowupCommand_NoFace             = 529
  VC_NoFollowupCommand_WithFace           = 530
  VC_Refuse_energy                        = 531
  VC_Refuse_repair                        = 532
  VC_Refuse_sparks                        = 533
  VC_StartledWakeup                       = 534
  WaitOnSideLoop                          = 535
  WorkoutPostLift_highEnergy              = 536
  WorkoutPostLift_lowEnergy               = 537
  WorkoutPostLift_mediumEnergy            = 538
  WorkoutPreLift_highEnergy               = 539
  WorkoutPreLift_lowEnergy                = 540
  WorkoutPreLift_mediumEnergy             = 541
  WorkoutPutDown_highEnergy               = 542
  WorkoutPutDown_lowEnergy                = 543
  WorkoutPutDown_lowEnergy_simple         = 544
  WorkoutPutDown_mediumEnergy             = 545
  WorkoutStrongLift_highEnergy            = 546
  WorkoutStrongLift_lowEnergy             = 547
  WorkoutStrongLift_mediumEnergy          = 548
  WorkoutTransition_highEnergy            = 549
  WorkoutTransition_lowEnergy             = 550
  WorkoutTransition_mediumEnergy          = 551
  WorkoutWeakLift_highEnergy              = 552
  WorkoutWeakLift_lowEnergy               = 553
  WorkoutWeakLift_mediumEnergy            = 554
  Count                                   = 555

Anki.Cozmo.AnimationTrigger = AnimationTrigger
del AnimationTrigger


class CubeAnimationTrigger(object):
  "Automatically-generated int_32 enumeration."
  Carrying                    = 0
  Connected                   = 1
  CubePouncePlayerLose        = 2
  CubePouncePlayerWin         = 3
  Dance_01                    = 4
  Dance_02                    = 5
  Dance_03                    = 6
  Dance_04                    = 7
  Dance_05                    = 8
  Dance_06                    = 9
  DanceFadeOff                = 10
  DrivingTo                   = 11
  FeedingBlank                = 12
  FeedingCyanCycle            = 13
  FeedingCyanSolid            = 14
  Flash                       = 15
  GatherCubesAllCubesInBeacon = 16
  GatherCubesCubeInBeacon     = 17
  GuardDogBeingMoved          = 18
  GuardDogBusted              = 19
  GuardDogOff                 = 20
  GuardDogSetup               = 21
  GuardDogSleeping            = 22
  GuardDogSuccessfullyFlipped = 23
  Interacting                 = 24
  InteractingBehaviorLock     = 25
  Onboarding                  = 26
  PyramidBaseBottom           = 27
  PyramidFlourish             = 28
  PyramidOnSideLocated        = 29
  PyramidOnSideNotLocated     = 30
  PyramidPickup               = 31
  PyramidSingle               = 32
  Sleep                       = 33
  SleepNoFade                 = 34
  SpeedTapWin                 = 35
  SpeedTapLose                = 36
  Visible                     = 37
  WakeUp                      = 38
  Workout                     = 39
  Count                       = 40

Anki.Cozmo.CubeAnimationTrigger = CubeAnimationTrigger
del CubeAnimationTrigger


